// closure to prevent namespace polution
var box1;
var box2;
var box3;
var boxCenterX = 25;
var boxCenterY = 25;
//the dot positions relative to the graph image
var boxGraphX = new Array(3);
var boxGraphY = new Array(3);
//the dot pos relavtive to the browswer window
var boxWindowX = new Array(3);
var boxWindowY = new Array(3);
//the dot pos relavtive to the browswer window
var boxImageX = new Array(3);
var boxImageY = new Array(3);
//

var imageTop, imageLeft;
var imageWidth = 2048;
var imageHeight = 2048;
var graphObject;
var elementWidth;
var elementScale;
var zoomMagnification = 1;
var headerOffset = 0;
var imageTopBorder, imageBottomBorder, imageLeftBorder, imageRightBorder;
var gridLength, gridHeight;
var cellWidth, cellHeight;
var horizontalCellCount = 20;
var verticalCellCount = 20;
var cellXUnit, cellYUnit;
var gridStartX;
var gridStartY;
var gridEndX;
var gridEndY;
var gridLeftPadding =179;
var gridRightPadding = 175;
var gridTopPadding = 257;
var gridBottomPadding = 222;
var gridTopLeft, gridTopRight, gridCenter;
var xQuadrant;
var yQuadrant;
var gridXEndingVal, gridXStartingVal, gridYEndingVal, gridYStartingVal;
var xInCellUnits = 0;
var yInCellUnits = 0;
var dotHolder;
var startDelay = 0;
var notchWrapper1;
var notchWrapper2;
var gotGraphObject = false;

//functions
function InitalizeImage() {
    gotGraphObject = true;
    graphObject = PinchZoomer.image;
    imageWidth = graphObject[0].naturalWidth;
    imageHeight = graphObject[0].naturalHeight;
    GetImageData();
}

function GetImageData() {
    //imgSize = graphObject.width();
    if (!gotGraphObject)
        return
    headerOffset = dotHolder.offset().top;
    imageLeft = graphObject.offset().left;
    imageTop = graphObject.offset().top;

    //zoomMagnification = graphObject[0]._gsTransform.scaleX;
}

///////////////////////////////////////////////////////////////////////////////////////////////
////////////DO MATH STUFF TO FIGURE OUT GRID COORDINATES AND CONVERT TO UNITS//////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
function CountCells() {
    horizontalCellCount = (imageWidth - imageLeftBorder - imageRightBorder) / cellWidth;
    verticalCellCount = (imageHeight - imageTopBorder - imageBottomBorder) / cellHeight;
}

function CalcaulateCellDimensions() {
    cellHeight = (imageHeight - gridTopPadding - gridBottomPadding) / verticalCellCount;
    cellWidth = (imageWidth - gridLeftPadding - gridRightPadding) / horizontalCellCount;
    //console.log("Cell Dimensions Height:" + cellHeight + " Width:" + cellWidth);
}

function CalculateCellUnitLength() {
    cellXUnit = ( gridXEndingVal - gridXStartingVal ) / horizontalCellCount;
    cellYUnit = (gridYEndingVal - gridYStartingVal) / verticalCellCount;
    //console.log("Cell Data ", cellXUnit, cellYUnit);
}

function CalculatePositionOnGrid(x, y) {
    var position = { x: 0.0, y: 0.0 };
    position.x = x * cellXUnit;
    position.y = y * cellYUnit;
    return position;
}

///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////


function InitializeBoxes() {
    var boxes = $(".box");
    box1 = boxes[0];
    box2 = boxes[1];
    box3 = boxes[2];
    SetCurrentBoxWindowPositions();
}

function InitializeGridDimensions() {
    GetImageData();
    gridStartX = imageLeft + gridLeftPadding;
    gridEndX = imageWidth - gridRightPadding;
    gridStartY = 0 + gridTopPadding;
    //console.log(imageTop + " + " + gridTopPadding);
    gridEndY = imageHeight - gridBottomPadding;
    gridTopLeft = { x: gridStartX, y: gridStartY };
    gridTopRight = { x: gridEndX, y: gridStartY };
    gridWidth = gridEndX - gridStartX;
    gridHeight = gridEndY - gridStartY;

}


//
function CalculateGraphImagePosition(xVal, yVal) {
    var graphPosition = { x: 0, y: 0 };
    graphPosition.x = (xVal - gridStartX);
    graphPosition.y = (yVal - gridStartY);
    //console.log(gridStartX + ',' + gridStartY);
    return graphPosition;
}

function CalculateGridPositionInPixels(xVal, yVal) {
    var gridPosition = { x: 0, y: 0 };
    gridPosition.x = (xVal - gridWidth / 2);
    gridPosition.y = (gridHeight / 2 - yVal);
    return gridPosition;
}

function CalculateGridNumber(xVal, yVal) {
    var endValue = { x: 0, y: 0 };
}

function CalculateQuadrant(xVal,yVal)
{
    if (xVal < 0)
    {
        xQuadrant = -1;
    }
    else if (xVal > 0)
    {
        xQuadrant = 1;
    }
    else
    {
        xQuadrant = 0;
    }
    if(yVal < 0)
    {
        yQuadrant = -1;
    }
    else if (yVal > 0)
    {
        yQuadrant = 1;
    }
    else
    {
        yQuadrant = 0;
    }
}

function CalculateBoxImagePosition() {
    CalculateBoxImagePositionWithIndex(0);
    CalculateBoxImagePositionWithIndex(1);
    CalculateBoxImagePositionWithIndex(2);
}

function CalculateBoxImagePositionWithIndex(index) {
    boxImageX[index] = (boxWindowX[index] - imageLeft + boxCenterX) / (elementScale * zoomMagnification);
    boxImageY[index] = (boxWindowY[index] - imageTop + headerOffset + boxCenterY) / (elementScale * zoomMagnification);
}


function CalculateBoxImagePositionWithXandY(xVal, yVal) {
    var position = { x: 0, y: 0 };
    position.x = (xVal - imageLeft) / (elementScale * zoomMagnification);
    position.y = (yVal - imageTop) / (elementScale * zoomMagnification);
    return position;
}


function CalculateBoxWindowPosition() {
    CalculateBoxWindowPositionWithIndex(0);
    CalculateBoxWindowPositionWithIndex(1);
    CalculateBoxWindowPositionWithIndex(2);
}

function CalculateBoxWindowPositionWithIndex(index) {
    boxWindowX[index] = (boxImageX[index] * elementScale * zoomMagnification) + imageLeft - boxCenterX;
    boxWindowY[index] = (boxImageY[index] * elementScale * zoomMagnification) + imageTop - headerOffset - boxCenterY;
    //console.log($('.dotholder').offset().top);
    ////console.log("Box" + index + " windowX:" + boxWindowX[index] + " = (" + boxImageX[index] + " * " + elementScale + " * " + zoomMagnification + ") + " + imageLeft);
    ////console.log("Box" + index + " windowY:" + boxWindowY[index] + " = (" + boxImageY[index] + " * " + elementScale + " * " + zoomMagnification + ") + " + imageTop + " + " + headerOffset + " - " + boxCenterY);
}

function CalculateWindowPostionFromImagePosition(xVal,yVal)
{
    var position = { x: 0, y: 0 };
    position.x = (xVal * elementScale * zoomMagnification) + imageLeft;
    position.y = (yVal * elementScale * zoomMagnification) + imageTop;
    return position;
}

function CalculateElementScale() {
    if (!gotGraphObject)
        return
    elementWidth = graphObject.width();
    elementScale = elementWidth / imageWidth;
}

function SetCurrentBoxWindowPositions() {
    SetCurrentBoxWindowPositionByIndex(0);
    SetCurrentBoxWindowPositionByIndex(1);
    SetCurrentBoxWindowPositionByIndex(2);
}

function SetCurrentBoxWindowPositionByIndex(index) {
    boxWindowX[index] = $('.box')[index].offsetLeft;
    boxWindowY[index] = $('.box')[index].offsetTop;
}

(function($) {
    
    //flags and tracking for step functions
    var dotevent = 1;     // for the Switch/Case statement
    var dotarray = []; //to track which dots are clicked
    var dot3 = "";     //to track which dots are clicked
	var azimuth;
	var elevation;
	
	$(window).load(function () { //this happens once //console.log('window loaded');
        
        
	    function INIT() {
	        setTimeout(function () {
	            //if we need to set css do it here
	            InitializeBoxes();
	            InitalizeImage();
	            GetImageData();
	            CalculateElementScale();
	            SetCurrentBoxWindowPositionByIndex(0);
	            SetCurrentBoxWindowPositionByIndex(1);
	            SetCurrentBoxWindowPositionByIndex(2);
	            CalculateBoxImagePosition();
	            InitializeGridDimensions();
	            CalcaulateCellDimensions();
	            CalculateCellUnitLength();
	            CalculateElementScale();
	            //console.log("CELL H:" + cellHeight + " W:" + cellWidth);
	            GetImageData();
	            placeDrags();
	            placeLines();
	            //console.log(startDelay);
	        }, startDelay);
	    }

	    var img = $('.dotholder').find('img');
	    dotHolder = $('.dotholder');
	    INIT();
	
	    //line and drag position variables
	    var boxCenterXOffset = 25;
	    var boxCenterYOffset = 25;
	    var lineCenteroffset = 25;
	    var topOffset = 0;
	    var leftOffset = 0;
	    var dot = $(".box");

	    $("#box1").css({"position": "absolute", "top": "15%", "left": "25%"});
        $("#box2").css({"position": "absolute", "top": "15%", "left": "50%"});
        $("#box3").css({"position": "absolute", "top": "30%", "left": "37%"});
		
		function placeDrags() { //couldn't break out into separate function
			$(".box").each(function(index, element){		
													
				CalculateBoxWindowPositionWithIndex(index);
                ////console.log(element + " index " + index);

                //new var to add px
                var newXpos = boxWindowX[index] + 'px';
                var newYpos = boxWindowY[index] + 'px';

                //places it on the page
                $(this).css({ left: newXpos, top: (newYpos), position: 'absolute' });						
			});
		}
		
		function placeLines() { //broke out into this and function below    
            // only continue if dots have been selected, thus lines should be showing
            if (dotarray.length != 2 || dot3 === "") {
                return;
            }
            GetImageData();
            
            //get the position of the dot and add 25px to draw the lines
			var x1 = $(dotarray[0]).offset().left + boxCenterXOffset;
			var x2 = $(dotarray[1]).offset().left + boxCenterXOffset;
			var x3 = $(dot3).offset().left + boxCenterXOffset;
			var y1 = $(dotarray[0]).offset().top + boxCenterYOffset;
			var y2 = $(dotarray[1]).offset().top + boxCenterYOffset;
			var y3 = $(dot3).offset().top + boxCenterYOffset;
			var z1 = $("#line2").offset().left + lineCenteroffset;
			var z2 = $("#line3").offset().left + lineCenteroffset;
			var z3 = $("#line4").offset().left + lineCenteroffset;
		  
			//center of the distance between two dots
			var line1MidPointX = (x2 - x1)/2 + x1;
			var line1MidPointY = (y2 - y1) / 2 + y1;

		    //notch vars
			var notch1X1, notch1X2;
			var notch1Y1, notch1Y2;

			var notch2X1, notch2X2;
			var notch2Y1, notch2Y2;

			var line1XMag, line2XMag;
			var line1YMag, line2YMag;
			var line1Length = Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
			var line2Length = Math.sqrt((line1MidPointX - x3) * (line1MidPointX - x3) + (line1MidPointY - y3) * (line1MidPointY - y3));
			
			var line2NotchPointX = (x3- line1MidPointX)/3 + line1MidPointX;
			var line2NotchPointY = (y3 - line1MidPointY)/3 + line1MidPointY;

			var hypotenuse = (line1Length);
			var hypotenuse2 =(line2Length);

			line1XMag = (x2 - x1) / line1Length;
			line2XMag = (line1MidPointX - x3) / line2Length
			line1YMag = (y1 - y2) / line1Length;
			line2YMag = (y3 - line1MidPointY) / line2Length;

			notch1X1 = line1MidPointX + line1YMag*5;
			notch1X2 = line1MidPointX - line1YMag*5;
			notch1Y1 = line1MidPointY + line1XMag*5;
			notch1Y2 = line1MidPointY - line1XMag*5;
            
			notch2X1 = line2NotchPointX + line2YMag*5;
			notch2X2 = line2NotchPointX - line2YMag*5;
			notch2Y1 = line2NotchPointY + line2XMag*5;
			notch2Y2 = line2NotchPointY - line2XMag*5;
			
			var notch1Hypotenuse = Math.sqrt((notch1X2 - notch1X1) *(notch1X2 - notch1X1) + (notch1Y2 - notch1Y1)*(notch1Y2 - notch1Y1));
			var notch2Hypotenuse = Math.sqrt((notch2X2 - notch2X1) * (notch2X2 - notch2X1) + (notch2Y2 - notch2Y1) * (notch2Y2 - notch2Y1));

			var notchPositionOnImage = CalculateBoxImagePositionWithXandY(line2NotchPointX, line2NotchPointY);
			var notchPositionOnGraph = CalculateGraphImagePosition(notchPositionOnImage.x, notchPositionOnImage.y);
			var notchPositionOnGrid = CalculateGridPositionInPixels(notchPositionOnGraph.x, notchPositionOnGraph.y);

			CalculateQuadrant(notchPositionOnGrid.x, notchPositionOnGrid.y);
			//console.log(notchPositionOnImage.x + " " + notchPositionOnImage.y);
			//console.log(notchPositionOnGraph.x + " " + notchPositionOnGraph.y);
			//console.log(notchPositionOnGrid.x + " " + notchPositionOnGrid.y);
			var GridXVal = (notchPositionOnGraph.x / cellWidth) |0;
			var GridYVal = (notchPositionOnGraph.y / cellHeight)|0;
			var RemainderX = notchPositionOnGraph.x % cellWidth;
			var RemainderY = notchPositionOnGraph.y % cellHeight;
			//GridYVal++;
			var PercentRemainY = RemainderY / cellHeight;
			//console.log("GridYVal:" + GridYVal + " Remain:" + PercentRemainY + " Rounded:" + Math.round(PercentRemainY));
			GridXVal += Math.round(RemainderX / cellWidth);
			GridYVal += Math.round(RemainderY / cellHeight);
			var lineXPosition = GridXVal * cellWidth;
			var lineYPosition = GridYVal * cellHeight;
			var lineStartX;
			var lineStartY;
			var linePosition = CalculateWindowPostionFromImagePosition(lineXPosition + gridLeftPadding, lineYPosition + gridTopPadding);
			linePosition.x -= $("#line3")[0].clientHeight / 2;
			linePosition.y -= $("#line3")[0].clientHeight / 2;
			if (xQuadrant > 0) {
			    lineStartX = imageWidth - gridRightPadding;
			}
			else if (xQuadrant <= 0) {
			    lineStartX = gridLeftPadding; 
			}

			if (yQuadrant > 0) {
			    lineStartY = gridTopPadding;
			}
			else if (yQuadrant <= 0) {
			    lineStartY = imageHeight - gridBottomPadding;
			    
			}
			var finalLinesStartingValues =  CalculateWindowPostionFromImagePosition(lineStartX, lineStartY);

			////console.log("xQuad:" + xQuadrant + " yQuad:" + yQuadrant + " yStart:" + lineStartY + " X:" + finalLinesStartingValues.x + " Y:" + finalLinesStartingValues.y + " GridX:" + GridXVal + " GridY:"+ GridYVal + " " + window.innerHeight  + " " +graphObject.height());

			if (dotevent == 5) {
			    azimuth = GridXVal * cellXUnit + gridXStartingVal;
			    elevation = GridYVal * cellYUnit + gridYStartingVal;
			    $('.instructtext').html("AZ:" + azimuth.toFixed(2) + " and EL: " + elevation.toFixed(2));
			}

			var VerticalHypotenuse = Math.abs(linePosition.y - finalLinesStartingValues.y) + $("#line3")[0].clientHeight / 2;
			var HorizontalHypotenuse = Math.abs(linePosition.x - finalLinesStartingValues.x) + $("#line3")[0].clientHeight / 2;


			var HorizontalLineAngle = Math.atan2((finalLinesStartingValues.y - finalLinesStartingValues.y), (finalLinesStartingValues.x - linePosition.x)) * (180 / Math.PI);
			if (HorizontalLineAngle >= 90 && HorizontalLineAngle < 180) {
			    //y1 = y1 - (y1 - y2);
			}
			if (HorizontalLineAngle > 0 && HorizontalLineAngle < 90) {
			    finalLinesStartingValues.x = finalLinesStartingValues.x - (finalLinesStartingValues.x - linePosition.x);
			    //y1 = y1 - (y1 - y2);
			}
			if (HorizontalLineAngle <= 0 && HorizontalLineAngle > -90) {
			    finalLinesStartingValues.x = finalLinesStartingValues.x - (finalLinesStartingValues.x - linePosition.x);
			}


			var VerticalLineAngle = Math.atan2((finalLinesStartingValues.y - linePosition.y), (finalLinesStartingValues.x - finalLinesStartingValues.x)) * (180 / Math.PI);
			if (VerticalLineAngle >= 90 && VerticalLineAngle < 180) {
			    finalLinesStartingValues.y = finalLinesStartingValues.y - (finalLinesStartingValues.y - linePosition.y);
			}
			if (VerticalLineAngle > 0 && VerticalLineAngle < 90) {
			    //finalLinesStartingValues.x = finalLinesStartingValues.x - (finalLinesStartingValues.x - finalLinesStartingValues.x);
			    finalLinesStartingValues.y = finalLinesStartingValues.y - (finalLinesStartingValues.y - linePosition.y);
			}
			if (VerticalLineAngle <= 0 && VerticalLineAngle > -90) {
			    //finalLinesStartingValues.x = finalLinesStartingValues.x - (finalLinesStartingValues.x - finalLinesStartingValues.x);
			}

			var angle = Math.atan2((y1 - y2), (x1 - x2)) * (180 / Math.PI);
			if (angle >= 90 && angle < 180) {
			    y1 = y1 - (y1 - y2);
			}
			if (angle > 0 && angle < 90) {
			    x1 = x1 - (x1 - x2);
			    y1 = y1 - (y1 - y2);
			}
			if (angle <= 0 && angle > -90) {
			    x1 = x1 - (x1 - x2);
			}
			
			var angle2 = Math.atan2((y3-line1MidPointY), (x3-line1MidPointX)) *  (180/Math.PI);
			if(angle2 >= 90 && angle2 < 180){
				y3 = y3 - (y3-line1MidPointY);
			}
			if(angle2 > 0 && angle2 < 90){
				x3 = x3 - (x3-line1MidPointX);
				y3 = y3 - (y3-line1MidPointY);
			}
			if(angle2 <= 0 && angle2 > -90){
				x3 = x3 - (x3-line1MidPointX);
			}

			var notch1Angle = Math.atan2((notch1Y1 - notch1Y2), (notch1X1 - notch1X2)) * (180 / Math.PI);
			if (notch1Angle >= 90 && notch1Angle < 180) {
			    notch1Y1 = notch1Y1 - (notch1Y1 - notch1Y2);
			}
			if (notch1Angle > 0 && notch1Angle < 90) {
			    notch1X1 = notch1X1 - (notch1X1 - notch1X2);
			    notch1Y1 = notch1Y1 - (notch1Y1 - notch1Y2);
			}
			if (notch1Angle <= 0 && notch1Angle > -90) {
			    notch1X1 = notch1X1 - (notch1X1 - notch1X2);
			}

			var notch2Angle = Math.atan2((notch2Y1 - notch2Y2), (notch2X1 - notch2X2)) * (180 / Math.PI);
			if (notch2Angle >= 90 && notch2Angle < 180) {
			    notch2Y1 = notch2Y1 - (notch2Y1 - notch2Y2);
			}
			if (notch2Angle > 0 && notch2Angle < 90) {
			    notch2X1 = notch2X1 - (notch2X1 - notch2X2);
			    notch2Y1 = notch2Y1 - (notch2Y1 - notch2Y2);
			}
			if (notch2Angle <= 0 && notch2Angle > -90) {
			    notch2X1 = notch2X1 - (notch2X1 - notch2X2);
			}
            
			//use queue
	     	$("#line").queue(function(){
				$(this).offset({top: y1, left: x1});
				$(this).dequeue();
			}).queue(function(){
				$(this).width(hypotenuse);http://localhost:62915/../23_splashscreens
				$(this).dequeue();
			}).queue(function(){
				$(this).rotate(angle);
				$(this).dequeue();
			});
            
			$("#line2").queue(function(){
				$(this).offset({top: y3, left: x3});
				$(this).dequeue();
			}).queue(function(){
				$(this).width(hypotenuse2);
				$(this).dequeue();
			}).queue(function(){
				$(this).rotate(angle2);
				$(this).dequeue();
			});
			
			var line3 = $("#line3");
			$("#line3").queue(function () {
			    $(this).offset({ top: linePosition.y, left: finalLinesStartingValues.x });
			    $(this).dequeue();
			}).queue(function () {
			    $(this).width(HorizontalHypotenuse);
			    $(this).dequeue();
			}).queue(function () {
			    $(this).rotate(HorizontalLineAngle);
			    $(this).dequeue();
			});
			var line4 = $("#line4");
			$("#line4").queue(function () {
			    $(this).offset({ top: finalLinesStartingValues.y, left: linePosition.x});
			    $(this).dequeue();
			}).queue(function () {
			    $(this).width(VerticalHypotenuse);
			    $(this).dequeue();
			}).queue(function () {
			    $(this).rotate(VerticalLineAngle);
			    $(this).dequeue();
			});

			$('#outerNotch1').queue(function () {
			    $(this).offset({ top: line1MidPointY-30, left: line1MidPointX-30});
			    $(this).dequeue();
			});

			$('#outerNotch2').queue(function () {
			    $(this).offset({ top: line2NotchPointY-30, left: line2NotchPointX-30 });
			    $(this).dequeue();
			});

			$('#notch2Highlight').queue(function () {
			    $(this).offset({ top: line2NotchPointY - 17.5, left: line2NotchPointX - 17.5 });
			    $(this).dequeue();
			});

			$('#notch1Highlight').queue(function () {
			    $(this).offset({ top: line1MidPointY - 17.5, left: line1MidPointX - 17.5 });
			    $(this).dequeue();
			});

			$("#notch1").queue(function () {
			    $(this).offset({ top: notch1Y1, left: notch1X1 });
			    $(this).dequeue();
			}).queue(function () {
			    $(this).width(notch1Hypotenuse);
			    $(this).dequeue();
			}).queue(function () {
			    $(this).rotate(notch1Angle);
			    $(this).dequeue();
			});

			$("#notch2").queue(function () {
			    $(this).offset({ top: notch2Y1, left: notch2X1 });
			    $(this).dequeue();
			}).queue(function () {
			    $(this).width(notch2Hypotenuse);
			    $(this).dequeue();
			}).queue(function () {
			    $(this).rotate(notch2Angle);
			    $(this).dequeue();
			});

			//notchWrapper1 = $('#outerNotch1');
			//notchWrapper2 = $('#outerNotch2');
			//notchWrapper1 = $("#notch1").offset({ top: notch1Y1, left: notch1X1 });
			//notchWrapper2 = $("#notch2").offset({ top: notch2Y1, left: notch2X1 });
		}
		//Adding in notch wrapper positions to match notch positions	
		function placeNotchWrapper() {
			//notchWrapper1 = $('#outerNotch1');
			//notchWrapper2 = $('#outerNotch2');
			//notchWrapper1 = $("#notch1").offset({ top: notch1Y1, left: notch1X1 });
			//notchWrapper2 = $("#notch2").offset({ top: notch2Y1, left: notch2X1 });
			
			//console.log('notchWrapper1 offset is: ' + notchWrapper1);	
		}

		//when box is dragging, move lines with it
		$(".box").draggable({ delay: 0, distance: 0},{
			drag: function(event, ui){
			    SetCurrentBoxWindowPositions();
			    placeLines();
			    CalculateBoxImagePosition();
			    GetImageData();
			    placeDrags();
			    placeLines();
			}
		});	
		
		//move drag and line position when window is resized manually	
			 $(window).resize(function(){
			     //here instead of in the function so we oget the old size and the new size only updates once per Resize
			     ////console.log("RESIZE");
			     CalculateElementScale();
			     GetImageData();
			     placeDrags();
			     placeLines();
		});

			$(document).on('pinchzoom', function (pz, obj1) {
			    zoomMagnification = obj1[0]._gsTransform.scaleX;
			    //console.log("ZoomMag :" + zoomMagnification);
			    CalculateElementScale();

			GetImageData();
			placeDrags();
			placeLines();
		});
			$(document).on('OnDrag', function (pz) {
			    GetImageData();
			    placeDrags();
			    placeLines();
			})
			$(".box").on('dragstop', function (event, ui) {
			        SetCurrentBoxWindowPositions();
			        placeLines();
			        CalculateBoxImagePosition();
			        //console.log("STARTED DRAGGING");
			        GetImageData();
			        placeDrags();
			        placeLines();
			});
//- - - individual functions - - - - - - - - - - - - - - - - - - - - -
        // Initialize the draggable
		function boxDragOn() {
		    
            $(".box").draggable({ delay: 0, distance: 0},{
                drag: function (event, ui) {
                    SetCurrentBoxWindowPositions();
                    placeLines();
                    CalculateBoxImagePosition();
                }
            });
        }       
        // turn the draggable off
        function boxDragOff() {
            $(".box").draggable( "destroy" );
        }
        //The click doesn't actually respond, only the mousedown and mouseup
        function boxClickOn() {    
            $( ".box" ).on({
                "mousedown.ammo": function() { 
                    $(this).addClass('after-glow');
                }
            });
        }
        //turn the click off
        function boxClickOff() {    
            $(".box").off("mousedown.ammo");
            $(".box").off("mouseup.ammo");
        }

        //highlight on dots
        function dragHLon() {
            $(".box").each(function (index, element) {
                $(this).draggable({ containment: '#containdots' });
            });
            $(".box").on('drag', function(event, ui) {
                $(this).addClass('after-glow');
            });
            $(".box").draggable({ delay: 0, distance: 0},{
                stop: function(event, ui){
                    $(this).removeClass('after-glow');
                }
            });
        }
        
        function notch1_HLon() {
            $("#outerNotch1").on("mousedown", function() {
                $("#notch1Highlight").show();
                $("#notch1").addClass('after-glow');
                placeLines();
            });
        }
        
        function notch1_HLoff() {
            $("#notch1Highlight").hide();
            $("#notch1").removeClass('after-glow');
            $("#line").off("mousedown");
        }
		
		 function notch2_HLon() {
		     $("#outerNotch2").on("mousedown", function () {
		         if (dotevent != 5) {
		             $("#notch2Highlight").show();
		             $("#notch2").addClass('after-glow');
		             placeLines();
		         }
            });
        }
        
        function notch2_HLoff() {
            $("#notch2Highlight").hide();
            $("#notch2").removeClass('after-glow');
            $("#line2").off("mousedown");
        }


//- - - step functions - - - - - - - - - - - - - - - - - - - - - 
   //step0 - Initial page setup    
    //display and hide things
        $("#box1").show();
        $("#box2").show();
        $("#box3").show();
        $("#box1").css({"position": "absolute", "top": "30%", "left": "20%"});
        $("#box2").css({"position": "absolute", "top": "30%", "left": "30%"});
        $("#box3").css({"position": "absolute", "top": "45%", "left": "25%"});
        $("#line").hide();
        $("#line2").hide();
		$("#line3").hide();
        $("#line4").hide();
        $("#notch1").css({"position": "absolute", "top": "0px", "left": "0px"});
		$("#outerNotch1").css({"position": "absolute", "top": "0px", "left": "0px"});
        $("#notch1").hide();
		$("#notch2").css({"position": "absolute", "top": "175px", "left": "100px"});
		$("#outerNotch2").css({"position": "absolute", "top": "175px", "left": "100px"});
		$("#notch2").hide();
        $('.instructtext').html("Place round impacts");
        $('#fixhover').find(".complete_step").html("Complete Placement");
    //dot functionality
        dragHLon();
		$('.box').draggable({ containment: '#containdots'});
    //bottom button
        $('.complete_step').button().button('enable');

        function step1_check() {
            // check if dotarray has two selected
            
            if (dotarray.length == 2) {
                // the placeLines() function defines what happens on each dot 
                // if a dot isn't in the array, it wasn't the two most recently clicked, so it's #box3
                if (($.inArray("#box1", dotarray) == -1)) { dot3 = "#box1"; }
                if (($.inArray("#box2", dotarray) == -1)) { dot3 = "#box2"; }
                if (($.inArray("#box3", dotarray) == -1)) { dot3 = "#box3"; }
                // requirements met; enable bottom button and change button text
                $('.complete_step').button().button('enable');
                $('#fixhover').find(".complete_step").html("Generate line 1");
                // place lines ahead of time
                SetCurrentBoxWindowPositions();
                placeLines();
                CalculateBoxImagePosition();
            }
        }
        
        function step1() {
        //display and hide things
            $("#line").hide();
            $("#line2").hide();
			$("#line3").hide();
        	$("#line4").hide();
			$("#notch2").hide();
            $('.instructtext').html("Select two round impacts");
            $('#fixhover').find(".complete_step").html("Generate line 1");
        //dot functionality
            boxDragOff();
        //bottom button
            $('.complete_step').button().button('disable');
        //flags and tracking   
            dotarray = []; // array starts out empty, no dots clicked
            $(".box").on('mouseup.ammo', function() {
                var id = "#" + $(this).attr("id"); //finds the dot's ID adds # to find it in the array later  
                
                // check if the selected dot is already in dotarray
                if ($.inArray(id, dotarray) == -1) { // if this dot isn't in the array (-1 means "not" in jQuery)        
                    if(dotarray.length < 2) { //and the array has less than 2 dots
                        dotarray.push(id); //add this dot in
                    } else {
                        dotarray.shift(); //remove the first dot in the array 
                        dotarray.push(id); // add this dot in
                    }
                    $(".box").removeClass('after-glow'); // remove .after-glow from all .box
                    for(var i = 0; i < dotarray.length; i++) // loop through items in dotarray
                        $(dotarray[i]).addClass('after-glow'); // add .after-glow to current dot (i)
                    
                    step1_check(); // perform the check for step1
                }
            });
        }
    
        // flags and tracking
        function step2_check() {
            // #notch1 and $(dot3) will have .after-glow when selected
            if ($("#notch1").hasClass('after-glow') && $(dot3).hasClass('after-glow')) {
                // requirements met; remove events from step2
                $("#line").off("mouseup");
				$("#notch1").off("mouseup");
                $(dot3).off("mouseup");
                
                // enable button with new text
                $('.complete_step').button().button('enable');
                $('#fixhover').find(".complete_step").html("Generate line 2");
				//console.log('step 2 check passed');
				dotevent = 3;			
            }
        }
        
        function step2() {
        //display and hide things  
            $("#line").show();
            $("#line2").hide();
			$("#line3").hide();
        	$("#line4").hide();
		 	$("#notch1").show();
			$("#notch2").hide();
            $('.instructtext').html("Select halfway mark and third round impact");
            $('#fixhover').find(".complete_step").html("Generate line 2");
            // remove after-glow from all boxes from previous step
            $(".box").removeClass('after-glow');

        //dot functionality
            $(".box").off("mouseup.ammo");
        //bottom button funtionality
            $('.complete_step').button().button('disable');
            
            placeLines();
            
           $("#outerNotch1").on("mouseup.ammo", function() { // assign a mouseup event to the line, for #notch1
               $("#notch1Highlight").show();
               $("#notch1").addClass('after-glow');
               placeLines();
                step2_check(); //flags and tracking
            });
			
			$("#outerNotch1").on("mouseup.ammo", function() { // assign a mouseup event to the line, for #notch1
			    $("#notch1Highlight").show();
			    $("#notch1").addClass('after-glow');
			    placeLines();
                step2_check(); //flags and tracking
            });
            
            $(dot3).on('mouseup.ammo', function() { // assign a mouseup event to the dot that was NOT selected
                $(this).addClass('after-glow');
                step2_check(); //flags and tracking
            });
        }
		
		function step3_check() {
            // #notch2 and $(dot3) will have .after-glow when selected
            if ($("#notch2").hasClass('after-glow')) {
                // requirements met; remove events from step2
                $("#outerNotch1").off("mouseup.ammo");
                // enable button with new text
                $('.complete_step').button().button('enable');
                $('#fixhover').find(".complete_step").html("Generate Discrete CCF");
				//console.log('step 3 check passed');
				dotevent = 4;		
            }
        }

        function step3() {		
		//console.log('step 3 ran');
        //display and hide things 
			$("#line").show();
			$("#line2").show();
			$("#notch2").show();
			placeLines();     
			$('.instructtext').html("Select the MPI ");
            $('#fixhover').find(".complete_step").html("Generate Discrete CCP");
            //dot functionality
            $("#notch1Highlight").hide();
            $("#notch1").removeClass('after-glow');
            $(dot3).removeClass('after-glow');
			boxDragOn();
			dragHLon();	
  
			$("#outerNotch2").on("mouseup.ammo", function () { // assign a mouseup event to the line, for #notch1
			    if (dotevent != 5) {
			        $("#notch2Highlight").show();
			        $('#notch2').addClass('after-glow');
			        placeLines();
			        step3_check(); //flags and tracking
			    }
            });			
			//bottom button funtionality
            $('.complete_step').button().button('disable');			
			//flags and tracking
			 step3_check();
        }
		
		
		 function step4() { // make two new lines, css, two new lines show, coordinates show, notch highlight is off, boxes are draggable
		 //console.log('step 4 ran');
		     //display and hide things		     
		 	$("#line").show();
			$("#line2").show();
		 	$("#line3").show();
        	$("#line4").show();
			$("#notch2").show();
			$("#notch2Highlight").hide();
			$("#notch2").removeClass('after-glow');
			$('.instructtext').html("AZ:" + azimuth + " and EL: " + elevation);
            		
		    //bottom button funtionality
			 $('.complete_step').button().button('disable');
			 $("#fixhover").hide();	
        }
		
        //attach step functions to button click 
        $(document).on('click', '[data-dots="completestep"]', function() {
            switch(dotevent) {
                case 1:
                    step1();										
                    dotevent = 2;
                    break;
                case 2:
                    step2();							
                    dotevent = 3;
                    break;
                case 3:
                    step3();
                    dotevent = 4;
                    placeDrags();
                    placeLines();
                    break;
                case 4:
                    step4();
                    dotevent = 5;
                    placeDrags();
                    placeLines();
                    break;
            }
        });
	     
    });	//--- end window load --- 
    
})(jQuery);